/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Linky
 *
 * The Initial Developer of the Original Code is Henrik Gemal.
 * Portions created by the Initial Developer are Copyright (C) 2002-2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Henrik Gemal http://gemal.dk
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// Put everything into a namespace so that we dont pollute
var LinkyShared = function() {}

LinkyShared.prototype.replaceInsert = function(t, i, v) {
	var result = t;
	var re = new RegExp("#" + i, "g");
	result = result.replace(re, v);
	return result;
}

// Dump message to the JavaScript console
// t : text message
// u : show message to the user?
// a : additional information
LinkyShared.prototype.trace = function(t, u, a) {
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var pref = prefService.getBranch(null);
	var CONSOLE_SERVICE = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);

	var dev;
	try {
		dev = pref.getBoolPref("extensions.linky.developer");
	} catch(err) {
	}
	t = "Linky - " + t;
	if (u) {
		var s = t;
		if (a) {
			s += "\nSee the JavaScript Console for more info";
		}
		alert(s);
		if (a) {
			t += " - info: " + a;
		}
		CONSOLE_SERVICE.logStringMessage(t);
	} else if (dev) {
		if (a) {
			t += " - info: " + a;
		}
		CONSOLE_SERVICE.logStringMessage(t);
	}
}

const linkyShared = new LinkyShared;
